<script setup lang="ts">
// import { title } from 'process'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { User } from '@/types/User'

const headers = [
  {
    title: 'Id',
    key: 'id'
  },
  {
    title: 'Email',
    key: 'email'
  },
  {
    title: 'Full Name',
    key: 'fullName',
    value: 'fullName'
  },
  {
    title: 'Gender',
    key: 'gender'
  },
  {
    title: 'Role',
    key: 'roles',
    value: (item: any | User) => item.roles.join(',')
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const initilUser: User = {
  id: -1,
  email: '',
  password: '',
  fullName: '',
  gender: 'male',
  roles: ['staff']
}
const editedUser = ref<User>(JSON.parse(JSON.stringify(initilUser)))

const users = ref<User[]>([])
let editedIndex = -1
let lastId = 4
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initilUser)
  })
}
function deleteItemConfirm() {
  // Delete item from list
  users.value.splice(editedIndex, 1)
  closeDelete()
}
function editItem(item: User) {
  editedIndex = users.value.indexOf(item)
  editedUser.value = Object.assign({}, item)
  dialog.value = true
}
function deleteItem(item: User) {
  editedIndex = users.value.indexOf(item)
  editedUser.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}
function initialize() {
  users.value = [
    {
      id: 1,
      email: 'admin',
      password: 'password',
      fullName: 'Arm',
      gender: 'male',
      roles: ['manager', 'staff']
    },
    {
      id: 2,
      email: 'user1',
      password: 'password',
      fullName: 'jing',
      gender: 'female',
      roles: ['staff']
    },
    {
      id: 3,
      email: 'user2',
      password: 'password',
      fullName: 'jung',
      gender: 'female',
      roles: ['staff']
    }
  ]
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initilUser)
    editedIndex = -1
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(users.value[editedIndex], editedUser.value)
  } else {
    editedUser.value.id = lastId++
    users.value.push(editedUser.value)
  }
  editedIndex = -1
  closeDialog()
}
onMounted(() => {
  initialize()
})
</script>
<template>
  <!-- <div>
    <v-table>
      <thead>
        <tr>
          <th class="text-left">ID</th>
          <th class="text-left">Email</th>
          <th class="text-left">full Name</th>
          <th class="text-left">Gender</th>
          <th class="text-left">Roles</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="item in users" :key="item.id">
          <td>{{ item.id }}</td>
          <td>{{ item.email }}</td>
          <td>{{ item.fullName }}</td>
          <td>{{ item.gender }}</td>
          <td>{{ item.roles.join(',') }}</td>
        </tr>
      </tbody>
    </v-table>
  </div> -->
  <div>
    <v-data-table :headers="headers" :items="users">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>User Management</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog-->

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props"> New user </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">User Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedUser.email"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Email"
                        ></v-text-field
                      ></v-col>
                      <v-col cols="12" sm="12" md="4"
                        ><v-text-field
                          v-model="editedUser.fullName"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="fullName"
                        ></v-text-field
                      ></v-col>
                      <v-col cols="12" sm="12" md="4"
                        ><v-text-field
                          v-model="editedUser.password"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Password"
                          placeholder="Enter your password"
                        ></v-text-field
                      ></v-col>
                      <v-col cols="12" sm="6"
                        ><v-combobox
                          label="Gender"
                          :items="['male', 'female', 'other']"
                          v-model="editedUser.gender"
                        ></v-combobox
                      ></v-col>
                      <v-col cols="12" sm="6"
                        ><v-combobox
                          v-model="editedUser.roles"
                          :items="[
                            { title: 'Admin', value: 'admin' },
                            { title: 'User', value: 'user' }
                          ]"
                          label="Select a roles"
                          multiple
                          :return-object="false"
                        ></v-combobox
                      ></v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="initialize"> Reset </v-btn>
      </template></v-data-table
    >
  </div>
</template>
